Unit adh3e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFH3E_p;

procedure adh3e(var A :Array of Extended; var D1 :Extended;
                var D2 :Integer; var RI :Array of Integer;
                var R :Array of Extended; var N :Integer); 
implementation

procedure adh3e(var A :Array of Extended; var D1 :Extended;
                var D2 :Integer; var RI :Array of Integer;
                var R :Array of Extended; var N :Integer);
var
IERR,I,K,LI,M,L :Integer;
label
_1,_2,_3,_4,_5,_6;
begin
AFH3E(A,N,RI,R,IERR);
if ( IERR = 0 )  
 then goto _1;
D1 := 0.e0;
D2 := 0;
goto _6;
_1:
K := 0;
D1 := 1.e0;
D2 := 0;
for I:=1 to N do
 begin
  K := K+I;
  LI := I+N;
  if ( RI[LI-1] = 1 ) 
   then goto _2;
  if ( RI[LI-1] = 0 ) 
   then goto _5;
  L := K+I+1;
  M := L-1;
  D1 := D1*(A[K-1]*A[L-1]-IntPower(A[M-1],2));
  goto _3;
_2:
  D1 := D1*A[K-1];
_3:
  if ( Abs(D1) < 1.e0 ) 
   then goto _4;
  D1 := D1*0.0625e0;
  D2 := D2+4;
  goto _3;
_4:
  if ( Abs(D1) >= 0.0625e0 ) 
   then goto _5;
  D1 := D1*16.e0;
  D2 := D2-4;
  goto _4;
_5:
 end;
_6:
end;

end.
